% Metryka nx=dp(x1,x2,p) 
%   function d = dp(x1,x2,p)
%
% x1 - pierwszy punkt lub zbir punktw wierszami
% x2 - drugi punktlub zbir punktw wierszamin
% p  - okresla dp

function y=dp(x1,x2,p)



[n1,m1]=size(x1);
[n2,m2]=size(x2);
if m1>1
    x2=x2';
    x0=kron(ones(1,n2),x1);
    x3=kron(ones(n1,1),x2(:)');
    rn=n1;
    rm=2*n2;
    x0=reshape(x0',m1,n2*n1)';
    x3=reshape(x3',m1,n2*n1)';
    if p==1    
        y=sum(abs(x0-x3)')';
    end;
    if p==2  
        y=sqrt(sum((x0-x3).^2'))';
    end;
    if p==inf
        y=max(abs(x0-x3)')';
    end;     
    y=reshape(y',n2,n1)';
else
    x0=kron(ones(1,n2),x1);
    x3=kron(ones(n1,1),x2(:)');
    rn=n1;
    rm=2*n2;
    x0=reshape(x0',m1,n2*n1)';
    x3=reshape(x3',m1,n2*n1)';
    y=(abs(x0-x3)')';
    y=reshape(y',n2,n1)';
end
    