 function [W,WX]=wtm(X,K)
[nn,mm]=size(X);
ind=irandk(nn,K);
W=X(ind,:);
kMax=200
etaMax=0.7;
etaMin=0.3;
lambdaMax=max(std(X))^2/1.5;
lambdaMin=max(std(X))^2/7;
for k=0:kMax
    ii=floor(rand(1)*nn)+1;
    eta=etaMax*(etaMin/etaMax)^(k/kMax);
    lambda=lambdaMax*(lambdaMin/lambdaMax)^(k/kMax);
    d=dp(X(ii,:),W,2);
    G=exp(-d.^2/lambda);
    dW=eta*(ones(mm,1)*G)'.*(ones(K,1)*X(ii,:)-W);
    W=W+dW;
end
d=dp(W,X,2);
[m,WX]=min(d);
