function [W, WX]=wta(X,K)
[nn,mm]=size(X)
ind=irandk(nn,K);
W=X(ind,:);
kMax=1000;
etaMax=0.8;
etaMin=0.3;
lambdaMax=K/2;
lambdaMin=K/50;
for k=0:kMax
    ii=floor(rand(1)*nn)+1;
    eta=etaMax*(etaMin/etaMax)^(k/kMax);
    lambda=lambdaMax*(lambdaMin/lambdaMax)^(k/kMax);
    d=dp(X(ii,:),W,2);
    [dSort,indSort]=sort(d);
    G(indSort)=exp(-([0:K-1])/lambda);
    dW=eta*(ones(mm,1)*G)'.*(ones(K,1)*X(ii,:)-W); 
    W=W+dW;   
end
d=dp(W,X,2);
[m,WX]=min(d);
